from flask import Flask, render_template, jsonify
from pprint import pprint


app = Flask(__name__)
app.debug = True

@app.route('/')
def index():
    return render_template("index.html")

@app.route('/game')
def game():
    return render_template("game.html")

@app.route('/player/<team_name>')
def player(team_name):
    return render_template("player.html", team_name=team_name)

@app.route('/admin')
def admin():
    return render_template("admin.html")

@app.route('/questions')
def questions():
    questions = []
    question_number = -1
    with open("questions.ini") as f:
        question = ""
        for line in f.readlines():
            if not line.strip():
                continue
            if line.startswith("["):
                question = line.strip().strip("[").strip("]")
                questions.append({"question":question, "answers":[]})
                question_number += 1
                continue
            else:
                answer, score = line.split("=")
                questions[question_number]["answers"].append({"answer":answer.strip(), "score":int(score.strip())})
                #print(line.strip())
        #pprint(questions)
    return jsonify({"questions":questions})
    
